
# Model Share Activiti App Extension

This is an Activiti App extension that implements automatic model sharing in APS.  Adding this extension will do nothing without additional configuration.

A model is any modeled object in APS.  For example, an App, Process, or Form.  When created, only the user can see or edit it by default.  They can manually and explicitly share it to any person or group in the system.  This step is often forgotten and sometimes the user that created doesn't exist anymore.  This extension intends to resolve that issue.

## Install

You can install this like any JAR extension.  It just needs to be put in the web container classpath.

## Configuration

There are several configuration properties available to shape how this extension shares models in your APS installation.

| Property                                                 | Default  | Purpose |
| -------------------------------------------------------- | -------- | ------- |
| `inteligr8.modelShareExtension.enabled`                  | `true`   | Enablement; `false` will disable all the behaviors of this extension. |
| `inteligr8.modelShareExtension.scanDelayInMillis`        | `30000`  | The delay before the first scan for all models to share. |
| `inteligr8.modelShareExtension.scanIntervalInMillis`     | `600000` | The interval between scans for all models to share. |
| `inteligr8.modelShareExtension.groups.canRead`           |          | What groups should be granted read permission to models of all types. |
| `inteligr8.modelShareExtension.groups.canWrite`          |          | What groups should be granted write permission to models of all types. |
| `inteligr8.modelShareExtension.groups.canReadApps`       |          | What groups should be granted read permission to App models. |
| `inteligr8.modelShareExtension.groups.canWriteApps`      |          | What groups should be granted write permission to App models. |
| `inteligr8.modelShareExtension.groups.canReadProcesses`  |          | What groups should be granted read permission to Process models. |
| `inteligr8.modelShareExtension.groups.canWriteProcesses` |          | What groups should be granted write permission to Process models. |
| `inteligr8.modelShareExtension.groups.canReadForms`      |          | What groups should be granted read permission to Form models. |
| `inteligr8.modelShareExtension.groups.canWriteForms`     |          | What groups should be granted write permission to Form models. |
| `inteligr8.modelShareExtension.modelChunkSize`           | `50`     | When querying for all models, how many models should be queried per page. |
| `inteligr8.modelShareExtension.shareChunkSize`           | `25`     | When querying all user/group share permissions on a single model, how many records should be queried per page. |

You can specify these at startup as JVM system properties.

When specifying groups, use commas to separate each entry.  You can also prefix each group with "sys:" or "org:" to target a specific system or organizational/functional group.  The extension will query by group name and then external ID in each case.

Any specification of a specific group permission (e.g. `canReadApps`) will override any specification for the same group in the generic `canRead` or `canWrite` property.
