/*
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.inteligr8.alfresco.activiti.share;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import com.activiti.api.boot.BootstrapConfigurer;

@Component
public class ActivitiBootstrapService implements BootstrapConfigurer {
    
    private final Logger logger = LoggerFactory.getLogger(this.getClass());
    
    @Autowired(required = false)
    private List<Bootstrappable> bootstrappables;
    
    @Override
    public void applicationContextInitialized(ApplicationContext applicationContext) {
        if (this.bootstrappables != null) {
            for (Bootstrappable bootstrappable : this.bootstrappables) {
                this.logger.debug("Bootstrapping: " + bootstrappable.getClass());
                bootstrappable.onBootstrap();
            }
        }
    }

}
